

Write-Host "Cration des utilisateurs dans l'Active Directory en cours ..."



#import du module Active Directory

    Import-Module activedirectory

#connexion  l'Active Directory

    $objOU=[ADSI]"LDAP://localhost:389/DC=M2L-Multimedia-A,DC=local"

    if($objOU.Children -ne $null) {

# importation des data du fichier csv (se placer dans le dossier !!)

    $dataSource=import-csv -Delimiter ";" .\user.csv
    $cpt = 0
	
    ForEach($dataRecord in $dataSource) {
        $ou="UO-"+$dataRecord.formation
        
    #vrification de l'existance de l'OU
        
        if(($objOU.Children | where {$_.Path -match "OU=$ou"}) -eq $null){
        
    #si elle n'existe pas on la cre
        
            $objOU = $objOU.create("organizationalUnit", "ou="+$ou)
            $objOU.SetInfo()
        
        }
        
        else {
        
    #sinon on place le curseur dessus pour que l'utilisateur soit cre dans la bonne OU
        
            $objOU = $objOU.Children.Find("OU=$ou")
        }
		$formation=$dataRecord.formation
        $groupe = "g_"+$dataRecord.formation
        $SamAccountName=$dataRecord.login
        $GivenName=$dataRecord.prenom
        $sn=$dataRecord.nom
        $cn=$GivenName + " " + $sn
        $displayName=$cn
        $UserPrincipalname=$SamAccountName +"@M2L-Multimedia-A.local"
		$mot_de_passe = $dataRecord.passe
		
		#On cre le groupe d'utilisateur si il n'existe pas deja 
		if(($objOU.Children | where {$_.Path -match "CN=$groupe"}) -eq $null) {
            $objGroupe = $objOU.Create("group", "cn=$groupe")
			$objGroupe.SetInfo() 
        }
		else
		{
			$objGroupe = [ADSI]"LDAP://localhost:389/cn=$groupe,ou=$ou,DC=M2L-Multimedia-A,DC=local"
		}
      
    #on cre l'objet utilisateur dans Active Directory
        
        $objUser=$objOU.Create("User","CN="+$cn)
	Write-Host "$cn"
        $objUser.Put("SamAccountName",$SamAccountName)
	Write-Host "$SamAccountName"
        $objUser.Put("UserPrincipalName",$UserPrincipalName)
	Write-Host "$UserPrincipalName"
        $objUser.Put("DisplayName",$Displayname)
	Write-Host "$displayName"
        #$objUser.Put("Description",$description)
        $objUser.Put("GivenName",$GivenName)
	Write-Host "$GivenName"
        $objUser.Put("sn",$sn)
	Write-Host "$sn"
	# Chemin du profil itinerrant
        $objUser.put("profilePath", "\\A-CD-01\Formation\$formation\Stagiaire\%username%\")
    # Chemin de la homedirectory
     #   $objUser.put("homeDirectory", "\\A-CD-01\Formation\$formation\Stagiaire\%username%\.V2")
    # Lettre de la homedirectory
     #   $objUser.put("homeDrive", "P:")
        $objUser.SetInfo()
        
        $objUser.setPassword($mot_de_passe)
   
    #on active le compte
        #$objUser.psbase.InvokeSet("AccountDisabled",$false)
		$objUser.userAccountControl[0] = $objUser.userAccountControl[0] -band (-bnot 2)
        $objUser.SetInfo()
		#ajout de l'utilisateur dans un groupe
        #$objGroupe.Put($SamAccountName, $groupe)
		#$objGroupe.SetInfo()
		Add-ADGroupMember -Identity "cn=$groupe,ou=$ou,DC=M2L-Multimedia-A,DC=local" -Member $SamAccountName 
    #on vrifie que l'utilisateur est bien cre et on rajoute le rsultat dans le fichier ADlog.txt
        
        if(($objOU.Children | where {$_.Path -match "CN=$cn"}) -ne $null) {
            "User : "+$UserPrincipalName+" Ok" | Add-Content C:\ADlog.txt
        }
        
        $objOU=[ADSI]"LDAP://localhost:389/DC=M2L-Multimedia-A,DC=local"
        
        }
        Write-Host "Cration russie!"
    
        
        }
        else {
        "Failure" | Add-Content C:\ADlog.txt
        }
